## nvidia-settings 1.0+3

=== Makefile ===
#
# nvidia-settings: A tool for configuring the NVIDIA X driver on Unix
# and Linux systems.
#
# Copyright (C) 2004 NVIDIA Corporation.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of Version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See Version 2
# of the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the:
#
#           Free Software Foundation, Inc.
#           59 Temple Place - Suite 330
#           Boston, MA 02111-1307, USA
#

#
# This is the top level Makefile for the nvidia-settings utility
#

# Below are variables that users can override, either here or on the
# make commandline
#
# CC = gcc
# CFLAGS = -Wall
# PKG_CONFIG = pkg-config
# X11R6_DIR = /usr/X11R6


# default definitions; can be overwritten by users

SHELL = /bin/sh
INSTALL = install -m 755
BUILD_OS := $(shell uname)

ifndef CC
  CC = gcc
endif

ifndef CFLAGS
  CFLAGS = -Wall -fpedantic
endif

ifndef PKG_CONFIG
  PKG_CONFIG = pkg-config
endif

ifndef X11R6_LIB_DIR
  X11R6_LIB_DIR = /usr/X11R6/lib
endif

ifndef X11R6_INC_DIR
  X11R6_INC_DIR = /usr/X11R6/include
endif

# the NVDEBUG environment variable controls whether we build debug or retail

ifeq ($(NVDEBUG),1)
  STRIP = true
  CFLAGS += -g -DDEBUG
else
  ifndef STRIP
    STRIP = strip
  endif
  CFLAGS += -O
endif

# default prefix
ifdef ROOT
  prefix = $(ROOT)/usr
else
  prefix = /usr/local
endif

exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin

X11R6_CFLAGS = -I $(X11R6_INC_DIR)

GTK_CFLAGS := $(shell $(PKG_CONFIG) --cflags gtk+-2.0)
GTK_LDFLAGS := $(shell $(PKG_CONFIG) --libs gtk+-2.0)

ifeq ($(BUILD_OS),SunOS)
LIBXV = -lXv
else
LIBXV = -Wl,-Bstatic -lXv -Wl,-Bdynamic
endif

X11R6_LIBS := -L $(X11R6_LIB_DIR) -Wl,-Bstatic -lXxf86vm -Wl,-Bdynamic $(LIBXV) -lX11 -lXext

XNVCTRL_LIB := src/libXNVCtrl/libXNVCtrl.a

CURDIR := $(shell pwd)

RELATIVE_SRCDIRS = \
	doc \
	src \
	src/image_data \
	src/xpm_data \
	src/gtk+-2.x \
	src/libXNVCtrl \
	src/libXNVCtrlAttributes

SRCDIRS := $(addprefix $(CURDIR)/, $(RELATIVE_SRCDIRS))

INC_FLAGS := $(addprefix -I , $(RELATIVE_SRCDIRS))

ALL_CFLAGS = $(CFLAGS) $(X11R6_CFLAGS) $(GTK_CFLAGS) $(INC_FLAGS)
ALL_LDFLAGS = $(LDFLAGS) $(GTK_LDFLAGS) $(X11R6_LIBS)

CPPFLAGS = $(ALL_CFLAGS)


NVIDIA_SETTINGS = nvidia-settings
NVIDIA_SETTINGS_VERSION = 1.0

NVIDIA_SETTINGS_DISTDIR = $(NVIDIA_SETTINGS)-$(NVIDIA_SETTINGS_VERSION)
NVIDIA_SETTINGS_DISTDIR_DIRS := \
	$(addprefix $(NVIDIA_SETTINGS_DISTDIR)/, $(RELATIVE_SRCDIRS))

STAMP_C = g_stamp.c

# Define the files in the SAMPLES directory

SAMPLES = Makefile README nv-control-dvc.c nv-control-info.c

# initialize SRC and EXTRA_DIST, then include each of the subdirectory
# Makefiles so that they can append to SRC and EXTRA_DIST

SRC =
EXTRA_DIST =

include $(patsubst %,%/Makefile.inc,$(RELATIVE_SRCDIRS))


# set VPATH 

VPATH = $(RELATIVE_SRCDIRS)


# additional sources (eg: generated sources) can be appended to ALL_SRC

ALL_SRC = $(SRC) $(STAMP_C)


# OBJS and DEPS are constructed such that they are placed into special
# ".objs" and ".deps" subdirectories

OBJS_DIR = .objs
DEPS_DIR = .deps

OBJS := $(patsubst %.c,$(OBJS_DIR)/%.o,$(ALL_SRC))
DEPS := $(patsubst %.c,$(DEPS_DIR)/%.d,$(SRC))

# default echo within SunOS sh does not have -n option. Use /usr/ucb/echo instead.
ifeq ($(BUILD_OS),SunOS)
ECHO=/usr/ucb/echo
else
ECHO=echo
endif

# and now, the build rules:

default: all

all: $(NVIDIA_SETTINGS)

install: $(NVIDIA_SETTINGS)
	$(STRIP) $<
	$(INSTALL) $< $(bindir)/$<

$(OBJS_DIR)/%.o: %.c
	@ mkdir -p $(OBJS_DIR)
	$(CC) -c $(ALL_CFLAGS) $< -o $@

$(DEPS_DIR)/%.d: %.c
	@ mkdir -p $(DEPS_DIR)
	@ set -e; b=`basename $* .c` ; \
	$(CC) -MM $(CPPFLAGS) $< \
	| sed "s%\\($$b\\)\\.o[ :]*%$(OBJS_DIR)/\\1.o $(DEPS_DIR)/\\1.d : %g" > $@; \
	[ -s $@ ] || rm -f $@

$(STAMP_C): $(filter-out $(OBJS_DIR)/$(STAMP_C:.c=.o), $(OBJS))
	@ rm -f $@
	@ $(ECHO) -n "const char NV_ID[] = \"nvidia id: " >> $@
	@ $(ECHO) -n "$(NVIDIA_SETTINGS):  " >> $@
	@ $(ECHO) -n "version $(NVIDIA_SETTINGS_VERSION)  " >> $@
	@ $(ECHO) -n "($(shell whoami)@$(shell hostname))  " >> $@
	@ echo    "$(shell date)\";" >> $@
	@ echo    "const char *pNV_ID = NV_ID + 11;" >> $@


%.i : %.c
	$(CC) $(CPPFLAGS) -E -dD $< | sed -e 's/^ $$//' > $@
	indent -kr -nbbo -l96 -sob $@


$(NVIDIA_SETTINGS): $(OBJS) $(XNVCTRL_LIB)
	$(CC) $(OBJS) $(ALL_CFLAGS) $(ALL_LDFLAGS) $(XNVCTRL_LIB) -o $@

.PHONY: dist clean clobber

dist:
	@ if [ -d $(NVIDIA_SETTINGS_DISTDIR) ]; then \
		chmod 755 $(NVIDIA_SETTINGS_DISTDIR); \
	fi
	@ if [ -f $(NVIDIA_SETTINGS_DISTDIR).tar.gz ]; \
		then chmod 644 $(NVIDIA_SETTINGS_DISTDIR).tar.gz; \
	fi
	rm -rf $(NVIDIA_SETTINGS_DISTDIR) $(NVIDIA_SETTINGS_DISTDIR).tar.gz
	mkdir -p $(NVIDIA_SETTINGS_DISTDIR_DIRS)
	@ for i in $(SRC); do \
		b=`find . -name $$i`; \
		if [ $$b ]; then \
			cp $$b $(NVIDIA_SETTINGS_DISTDIR)/$$b ; \
			chmod 644 $(NVIDIA_SETTINGS_DISTDIR)/$$b ; \
		fi ; \
	done
	@ for i in $(EXTRA_DIST); do \
		b=`find . -name $$i`; \
		if [ $$b ]; then \
			cp $$b $(NVIDIA_SETTINGS_DISTDIR)/$$b ; \
			chmod 644 $(NVIDIA_SETTINGS_DISTDIR)/$$b ; \
		fi ; \
	done
	mkdir -p $(NVIDIA_SETTINGS_DISTDIR)/samples
	@ for i in $(SAMPLES); do \
		cp samples/$$i $(NVIDIA_SETTINGS_DISTDIR)/samples/ ; \
	done
	@ for i in COPYING Makefile doc/Makefile.inc `find src -name Makefile.inc`; do \
		cp $$i $(NVIDIA_SETTINGS_DISTDIR)/$$i ; \
		chmod 644 $(NVIDIA_SETTINGS_DISTDIR)/$$i ; \
	done
	tar czf $(NVIDIA_SETTINGS_DISTDIR).tar.gz $(NVIDIA_SETTINGS_DISTDIR)
	rm -rf $(NVIDIA_SETTINGS_DISTDIR)

clean clobber:
	rm -rf $(OBJS_DIR) $(DEPS_DIR) $(STAMP_C) $(NVIDIA_SETTINGS)
	find . -name "*~" -exec rm -f \{\} \;

-include $(DEPS)

=== samples/Makefile ===
#
# nvidia-settings: A tool for configuring the NVIDIA X driver on Unix
# and Linux systems.
#
# Copyright (C) 2004 NVIDIA Corporation.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of Version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See Version 2
# of the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the:
#
#           Free Software Foundation, Inc.
#           59 Temple Place - Suite 330
#           Boston, MA 02111-1307, USA
#

#
# Makefile for Sample NV-CONTROL clients
#

# Below are variables that users can override, either here or on the
# make commandline
#
# CC = gcc
# CFLAGS = -Wall
# LDFLAGS = 
# X11R6_INC_DIR = /usr/X11R6/include
# X11R6_LIB_DIR = /usr/X11R6/lib/

ifndef CC
  CC = gcc
endif

ifndef CFLAGS
  CFLAGS = -Wall -fpedantic
endif

ifndef LDFLAGS
  LDFLAGS =
endif

ifndef X11R6_INC_DIR
  X11R6_INC_DIR = /usr/X11R6/include/
endif

ifndef X11R6_LIB_DIR
  X11R6_LIB_DIR = /usr/X11R6/lib/
endif

LIBXNVCTRL_DIR = ../src/libXNVCtrl


ALL_CFLAGS = $(CFLAGS) -I $(LIBXNVCTRL_DIR) -I $(X11R6_INC_DIR)
ALL_LDFLAGS = $(LDFLAGS) -L $(LIBXNVCTRL_DIR) -L $(X11R6_LIB_DIR) \
	-lXNVCtrl -lXext -lX11

SAMPLES = nv-control-info nv-control-dvc nv-control-events

all: $(SAMPLES)

% : %.c
	$(CC) $(ALL_CFLAGS) $< -o $@ $(ALL_LDFLAGS)

clean:
	rm -rf *.o *~ $(SAMPLES)

## nvidia-settings 0.01

=== debian/changelog ===
nvidia-settings (1:0.01) precise; urgency=medium

  * Initial release.

 -- Shengyao Xue <shengyao.xue@canonical.com>  Tue, 23 Dec 2014 18:36:58 +0800

=== debian/control ===
Source: nvidia-settings
Section: devel
Priority: optional
Maintainer: Shengyao Xue <shengyao.xue@canonical.com>
Build-Depends: debhelper (>= 7.0.50~) 

Package: nvidia-settings
Architecture: all
Depends:
Description: for retire nvidia-settings

## nvidia-settings 1.0+20060516

=== Makefile ===
--- 
+++ 
@@ -33,43 +33,53 @@
 # PKG_CONFIG = pkg-config
 # X11R6_DIR = /usr/X11R6
 
+# default build target
+
+default: all
+
 
 # default definitions; can be overwritten by users
 
 SHELL = /bin/sh
-INSTALL = install -m 755
+INSTALL = install
 BUILD_OS := $(shell uname)
+BUILD_ARCH := $(shell uname -m)
+M4 := m4
 
 ifndef CC
   CC = gcc
 endif
 
-ifndef CFLAGS
-  CFLAGS = -Wall -fpedantic
-endif
-
 ifndef PKG_CONFIG
   PKG_CONFIG = pkg-config
 endif
 
 ifndef X11R6_LIB_DIR
-  X11R6_LIB_DIR = /usr/X11R6/lib
+  ifeq ($(BUILD_OS)-$(BUILD_ARCH),Linux-x86_64)
+    X11R6_LIB_DIR = /usr/X11R6/lib64
+  else
+    X11R6_LIB_DIR = /usr/X11R6/lib
+  endif
 endif
 
 ifndef X11R6_INC_DIR
   X11R6_INC_DIR = /usr/X11R6/include
 endif
 
+# define local variables
+
+LOCAL_CFLAGS = -Wall
+
 # the NVDEBUG environment variable controls whether we build debug or retail
 
 ifeq ($(NVDEBUG),1)
   STRIP = true
-  CFLAGS += -g -DDEBUG
+  LOCAL_CFLAGS += -g -DDEBUG
 else
   ifndef STRIP
     STRIP = strip
   endif
-  CFLAGS += -O
+  LOCAL_CFLAGS += -O -DNDEBUG
 endif
 
 # default prefix
@@ -79,21 +89,36 @@
   prefix = /usr/local
 endif
 
+# default echo within SunOS sh does not have -n option. Use /usr/ucb/echo instead.
+# Solaris install has a different argument syntax 
+ifeq ($(BUILD_OS),SunOS)
+ECHO=/usr/ucb/echo
+define INSTALL_RULE
+	$(INSTALL) -m 755 -f $(bindir) $(NVIDIA_SETTINGS)
+	mkdir -p $(mandir)
+	$(INSTALL) -m 644 -f $(mandir) doc/$(MANPAGE)
+endef
+LD_RUN_FLAG=-R/usr/X11R6/lib
+else
+ECHO=echo
+define INSTALL_RULE
+	$(INSTALL) -m 755 $(NVIDIA_SETTINGS) $(bindir)/$(NVIDIA_SETTINGS)
+	mkdir -p $(mandir)
+	$(INSTALL) -m 644 doc/$(MANPAGE) $(mandir)
+	gzip -9f $(mandir)/$(MANPAGE)
+endef
+endif
+
 exec_prefix = $(prefix)
 bindir = $(exec_prefix)/bin
+mandir = $(exec_prefix)/share/man/man1
 
 X11R6_CFLAGS = -I $(X11R6_INC_DIR)
 
 GTK_CFLAGS := $(shell $(PKG_CONFIG) --cflags gtk+-2.0)
 GTK_LDFLAGS := $(shell $(PKG_CONFIG) --libs gtk+-2.0)
 
-ifeq ($(BUILD_OS),SunOS)
-LIBXV = -lXv
-else
-LIBXV = -Wl,-Bstatic -lXv -Wl,-Bdynamic
-endif
-
-X11R6_LIBS := -L $(X11R6_LIB_DIR) -Wl,-Bstatic -lXxf86vm -Wl,-Bdynamic $(LIBXV) -lX11 -lXext
+X11R6_LIBS := -L $(X11R6_LIB_DIR) -Wl,-Bstatic -lXxf86vm -Wl,-Bdynamic -lX11 -lXext
 
 XNVCTRL_LIB := src/libXNVCtrl/libXNVCtrl.a
 
@@ -112,8 +137,8 @@
 
 INC_FLAGS := $(addprefix -I , $(RELATIVE_SRCDIRS))
 
-ALL_CFLAGS = $(CFLAGS) $(X11R6_CFLAGS) $(GTK_CFLAGS) $(INC_FLAGS)
-ALL_LDFLAGS = $(LDFLAGS) $(GTK_LDFLAGS) $(X11R6_LIBS)
+ALL_CFLAGS = $(CFLAGS) $(LOCAL_CFLAGS) $(X11R6_CFLAGS) $(GTK_CFLAGS) $(INC_FLAGS)
+ALL_LDFLAGS = $(LD_RUN_FLAG) $(LDFLAGS) $(GTK_LDFLAGS) $(X11R6_LIBS)
 
 CPPFLAGS = $(ALL_CFLAGS)
 
@@ -127,9 +152,20 @@
 
 STAMP_C = g_stamp.c
 
+MANPAGE = nvidia-settings.1
+
 # Define the files in the SAMPLES directory
 
-SAMPLES = Makefile README nv-control-dvc.c nv-control-info.c
+SAMPLES = \
+	Makefile \
+	nv-control-dpy.c \
+	nv-control-dvc.c \
+	nv-control-events.c \
+	nv-control-info.c \
+	nv-control-targets.c \
+	nv-ddcci-client.c \
+	nv-control-framelock.c \
+	README
 
 # initialize SRC and EXTRA_DIST, then include each of the subdirectory
 # Makefiles so that they can append to SRC and EXTRA_DIST
@@ -159,22 +195,13 @@
 OBJS := $(patsubst %.c,$(OBJS_DIR)/%.o,$(ALL_SRC))
 DEPS := $(patsubst %.c,$(DEPS_DIR)/%.d,$(SRC))
 
-# default echo within SunOS sh does not have -n option. Use /usr/ucb/echo instead.
-ifeq ($(BUILD_OS),SunOS)
-ECHO=/usr/ucb/echo
-else
-ECHO=echo
-endif
-
 # and now, the build rules:
 
-default: all
-
-all: $(NVIDIA_SETTINGS)
-
-install: $(NVIDIA_SETTINGS)
-	$(STRIP) $<
-	$(INSTALL) $< $(bindir)/$<
+all: $(NVIDIA_SETTINGS) doc/$(MANPAGE)
+
+install: all
+	$(STRIP) $(NVIDIA_SETTINGS)
+	$(INSTALL_RULE)
 
 $(OBJS_DIR)/%.o: %.c
 	@ mkdir -p $(OBJS_DIR)

## nvidia-settings 1.0+20080304

=== Makefile ===
--- 
+++ 
@@ -54,16 +54,16 @@
   PKG_CONFIG = pkg-config
 endif
 
-ifndef X11R6_LIB_DIR
+ifndef X11_LIB_DIRS
   ifeq ($(BUILD_OS)-$(BUILD_ARCH),Linux-x86_64)
-    X11R6_LIB_DIR = /usr/X11R6/lib64
+    X11_LIB_DIRS = -L/usr/X11R6/lib64
   else
-    X11R6_LIB_DIR = /usr/X11R6/lib
+    X11_LIB_DIRS = -L/usr/X11R6/lib
   endif
 endif
 
-ifndef X11R6_INC_DIR
-  X11R6_INC_DIR = /usr/X11R6/include
+ifndef X11_INC_DIRS
+  X11_INC_DIRS = -I/usr/X11R6/include
 endif
 
 # define local variables
@@ -113,14 +113,17 @@
 bindir = $(exec_prefix)/bin
 mandir = $(exec_prefix)/share/man/man1
 
-X11R6_CFLAGS = -I $(X11R6_INC_DIR)
+X11_CFLAGS = $(X11_INC_DIRS)
 
 GTK_CFLAGS := $(shell $(PKG_CONFIG) --cflags gtk+-2.0)
 GTK_LDFLAGS := $(shell $(PKG_CONFIG) --libs gtk+-2.0)
 
-X11R6_LIBS := -L $(X11R6_LIB_DIR) -Wl,-Bstatic -lXxf86vm -Wl,-Bdynamic -lX11 -lXext
+X11_LIBS := $(X11_LIB_DIRS) -Wl,-Bstatic -lXxf86vm -Wl,-Bdynamic -lX11 -lXext
 
 XNVCTRL_LIB := src/libXNVCtrl/libXNVCtrl.a
+
+XF86PARSER_LIB := src/XF86Config-parser/libXF86Config-parser.a
+XF86PARSER_DIR := src/XF86Config-parser
 
 CURDIR := $(shell pwd)
 
@@ -131,14 +134,17 @@
 	src/xpm_data \
 	src/gtk+-2.x \
 	src/libXNVCtrl \
-	src/libXNVCtrlAttributes
+	src/libXNVCtrlAttributes \
+	src/XF86Config-parser \
+	samples
+
 
 SRCDIRS := $(addprefix $(CURDIR)/, $(RELATIVE_SRCDIRS))
 
 INC_FLAGS := $(addprefix -I , $(RELATIVE_SRCDIRS))
 
-ALL_CFLAGS = $(CFLAGS) $(LOCAL_CFLAGS) $(X11R6_CFLAGS) $(GTK_CFLAGS) $(INC_FLAGS)
-ALL_LDFLAGS = $(LD_RUN_FLAG) $(LDFLAGS) $(GTK_LDFLAGS) $(X11R6_LIBS)
+ALL_CFLAGS = $(CFLAGS) $(LOCAL_CFLAGS) $(X11_CFLAGS) $(GTK_CFLAGS) $(INC_FLAGS)
+ALL_LDFLAGS = $(LD_RUN_FLAG) $(LDFLAGS) $(GTK_LDFLAGS) $(X11_LIBS)
 
 CPPFLAGS = $(ALL_CFLAGS)
 
@@ -154,18 +160,6 @@
 
 MANPAGE = nvidia-settings.1
 
-# Define the files in the SAMPLES directory
-
-SAMPLES = \
-	Makefile \
-	nv-control-dpy.c \
-	nv-control-dvc.c \
-	nv-control-events.c \
-	nv-control-info.c \
-	nv-control-targets.c \
-	nv-ddcci-client.c \
-	nv-control-framelock.c \
-	README
 
 # initialize SRC and EXTRA_DIST, then include each of the subdirectory
 # Makefiles so that they can append to SRC and EXTRA_DIST
@@ -206,12 +200,21 @@
 $(OBJS_DIR)/%.o: %.c
 	@ mkdir -p $(OBJS_DIR)
 	$(CC) -c $(ALL_CFLAGS) $< -o $@
+
+# to generate the dependency files, use the compiler's "-MM" option to
+# generate output of the form "foo.o : foo.c foo.h"; then, use sed to
+# replace the target with "$(OBJS_DIR)/foo.o $(DEPS_DIR)/foo.d", and
+# wrap the prerequisites with $(wildcard ...); the wildcard function
+# serves as an existence filter, so that files that are later removed
+# from the build do not cause stale references.
 
 $(DEPS_DIR)/%.d: %.c
 	@ mkdir -p $(DEPS_DIR)
 	@ set -e; b=`basename $* .c` ; \
 	$(CC) -MM $(CPPFLAGS) $< \
-	| sed "s%\\($$b\\)\\.o[ :]*%$(OBJS_DIR)/\\1.o $(DEPS_DIR)/\\1.d : %g" > $@; \
+	| sed \
+	-e "s%\\($$b\\)\\.o[ :]*%$(OBJS_DIR)/\\1.o $(DEPS_DIR)/\\1.d : $$\(wildcard %g" \
+	-e "s,\([^\\]\)$$,\1)," > $@; \
 	[ -s $@ ] || rm -f $@
 
 $(STAMP_C): $(filter-out $(OBJS_DIR)/$(STAMP_C:.c=.o), $(OBJS))
@@ -228,42 +231,32 @@
 	$(CC) $(CPPFLAGS) -E -dD $< | sed -e 's/^ $$//' > $@
 	indent -kr -nbbo -l96 -sob $@
 
-
-$(NVIDIA_SETTINGS): $(OBJS) $(XNVCTRL_LIB)
-	$(CC) $(OBJS) $(ALL_CFLAGS) $(ALL_LDFLAGS) $(XNVCTRL_LIB) -o $@
-
-.PHONY: dist clean clobber
+$(XF86PARSER_LIB):
+	$(MAKE) NV_CFLAGS='$(NV_CFLAGS)' -C $(XF86PARSER_DIR)
+
+$(NVIDIA_SETTINGS): $(OBJS) $(XNVCTRL_LIB) $(XF86PARSER_LIB)
+	$(CC) $(OBJS) $(ALL_CFLAGS) $(ALL_LDFLAGS) $(XNVCTRL_LIB) $(XF86PARSER_LIB) -o $@
+
+.PHONY: $(XF86PARSER_LIB) dist clean clobber
 
 dist:
 	@ if [ -d $(NVIDIA_SETTINGS_DISTDIR) ]; then \
 		chmod 755 $(NVIDIA_SETTINGS_DISTDIR); \
 	fi
-	@ if [ -f $(NVIDIA_SETTINGS_DISTDIR).tar.gz ]; \
-		then chmod 644 $(NVIDIA_SETTINGS_DISTDIR).tar.gz; \
+	@ if [ -f $(NVIDIA_SETTINGS_DISTDIR).tar.gz ]; then \
+		chmod 644 $(NVIDIA_SETTINGS_DISTDIR).tar.gz; \
 	fi
 	rm -rf $(NVIDIA_SETTINGS_DISTDIR) $(NVIDIA_SETTINGS_DISTDIR).tar.gz
 	mkdir -p $(NVIDIA_SETTINGS_DISTDIR_DIRS)
-	@ for i in $(SRC); do \
-		b=`find . -name $$i`; \
-		if [ $$b ]; then \
-			cp $$b $(NVIDIA_SETTINGS_DISTDIR)/$$b ; \
-			chmod 644 $(NVIDIA_SETTINGS_DISTDIR)/$$b ; \
-		fi ; \
-	done
-	@ for i in $(EXTRA_DIST); do \
-		b=`find . -name $$i`; \
-		if [ $$b ]; then \
-			cp $$b $(NVIDIA_SETTINGS_DISTDIR)/$$b ; \
-			chmod 644 $(NVIDIA_SETTINGS_DISTDIR)/$$b ; \
-		fi ; \
-	done
-	mkdir -p $(NVIDIA_SETTINGS_DISTDIR)/samples
-	@ for i in $(SAMPLES); do \
-		cp samples/$$i $(NVIDIA_SETTINGS_DISTDIR)/samples/ ; \
-	done
-	@ for i in COPYING Makefile doc/Makefile.inc `find src -name Makefile.inc`; do \
-		cp $$i $(NVIDIA_SETTINGS_DISTDIR)/$$i ; \
-		chmod 644 $(NVIDIA_SETTINGS_DISTDIR)/$$i ; \
+	@ for inc_dir in $(RELATIVE_SRCDIRS) .; do \
+		EXTRA_DIST=; \
+		SRC=; \
+		mkdir -p $(NVIDIA_SETTINGS_DISTDIR)/$$inc_dir; \
+		for inc_file in `$(MAKE) --makefile $$inc_dir/Makefile.inc dist_list`; do \
+			file="$$inc_dir/$$inc_file"; \
+			cp $$file $(NVIDIA_SETTINGS_DISTDIR)/$$file; \
+			chmod 644 $(NVIDIA_SETTINGS_DISTDIR)/$$file; \
+		done; \
 	done
 	tar czf $(NVIDIA_SETTINGS_DISTDIR).tar.gz $(NVIDIA_SETTINGS_DISTDIR)
 	rm -rf $(NVIDIA_SETTINGS_DISTDIR)

=== samples/Makefile ===
--- 
+++ 
@@ -34,12 +34,15 @@
 # X11R6_INC_DIR = /usr/X11R6/include
 # X11R6_LIB_DIR = /usr/X11R6/lib/
 
+BUILD_OS := $(shell uname)
+BUILD_ARCH := $(shell uname -m)
+
 ifndef CC
   CC = gcc
 endif
 
 ifndef CFLAGS
-  CFLAGS = -Wall -fpedantic
+  CFLAGS = -Wall 
 endif
 
 ifndef LDFLAGS
@@ -51,7 +54,11 @@
 endif
 
 ifndef X11R6_LIB_DIR
-  X11R6_LIB_DIR = /usr/X11R6/lib/
+  ifeq ($(BUILD_OS)-$(BUILD_ARCH),Linux-x86_64)
+    X11R6_LIB_DIR = /usr/X11R6/lib64
+  else
+    X11R6_LIB_DIR = /usr/X11R6/lib
+  endif
 endif
 
 LIBXNVCTRL_DIR = ../src/libXNVCtrl
@@ -61,7 +68,14 @@
 ALL_LDFLAGS = $(LDFLAGS) -L $(LIBXNVCTRL_DIR) -L $(X11R6_LIB_DIR) \
 	-lXNVCtrl -lXext -lX11
 
-SAMPLES = nv-control-info nv-control-dvc nv-control-events
+SAMPLES = \
+	nv-control-info \
+	nv-control-dvc \
+	nv-control-events \
+	nv-ddcci-client \
+	nv-control-dpy \
+	nv-control-targets \
+	nv-control-framelock
 
 all: $(SAMPLES)

=== src/XF86Config-parser/Makefile ===
SRC = \
	DRI.c \
	Device.c \
	Files.c \
	Flags.c \
	Input.c \
	Keyboard.c \
	Layout.c \
	Module.c \
	Monitor.c \
	Pointer.c \
	Screen.c \
	Vendor.c \
	Video.c \
	Read.c \
	Scan.c \
	Write.c \
	Util.c \
	Extensions.c \
	Generate.c \
	Merge.c

OBJS = $(SRC:%.c=%.o)
DEPS = $(SRC:%.c=%.d)

ifndef CC
  CC = gcc
endif

CFLAGS = -Wall -g

ifdef NV_CFLAGS
  CFLAGS += $(NV_CFLAGS)
endif

ifndef RANLIB
  RANLIB = ranlib
endif

LIB = libXF86Config-parser.a
LIB_O = $(LIB:%.a=%.o)

default all: $(LIB)

.PHONY: clean clobber

$(LIB): $(OBJS)
	$(LD) -r -o $(LIB_O) $(OBJS)
	$(AR) ruv $(LIB) $(LIB_O)
	$(RANLIB) $(LIB)

%.o: %.c
	$(CC) -c $(CFLAGS) $< -o $@

%.d: %.c
	@set -e; $(CC) -MM $(CPPFLAGS) $< \
		| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
		[ -s $@ ] || rm -f $@

clean clobber:
	rm -rf *.o *~ *.d $(LIB) $(LIB_O)

-include $(DEPS)

## nvidia-settings 180.25

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,7 @@
+DESTDIR=
+ROOT=$(DESTDIR)
+X11R6_LIB_DIR = /usr/lib
+
 #
 # nvidia-settings: A tool for configuring the NVIDIA X driver on Unix
 # and Linux systems.
@@ -121,6 +125,7 @@
 X11_LIBS := $(X11_LIB_DIRS) -Wl,-Bstatic -lXxf86vm -Wl,-Bdynamic -lX11 -lXext
 
 XNVCTRL_LIB := src/libXNVCtrl/libXNVCtrl.a
+XNVCTRL_DIR := src/libXNVCtrl
 
 XF86PARSER_LIB := src/XF86Config-parser/libXF86Config-parser.a
 XF86PARSER_DIR := src/XF86Config-parser
@@ -234,12 +239,15 @@
 $(XF86PARSER_LIB):
 	$(MAKE) NV_CFLAGS='$(NV_CFLAGS)' -C $(XF86PARSER_DIR)
 
+$(XNVCTRL_LIB):
+	$(MAKE) CFLAGS='$(ALL_CFLAGS)' LDFLAGS='$(ALL_LDFLAGS)' -C $(XNVCTRL_DIR)
+
 $(NVIDIA_SETTINGS): $(OBJS) $(XNVCTRL_LIB) $(XF86PARSER_LIB)
 	$(CC) $(OBJS) $(ALL_CFLAGS) $(ALL_LDFLAGS) $(XNVCTRL_LIB) $(XF86PARSER_LIB) -o $@
 
 .PHONY: $(XF86PARSER_LIB) dist clean clobber
 
-dist:
+dist: $(XNVCTRL_LIB)
 	@ if [ -d $(NVIDIA_SETTINGS_DISTDIR) ]; then \
 		chmod 755 $(NVIDIA_SETTINGS_DISTDIR); \
 	fi
@@ -262,7 +270,7 @@
 	rm -rf $(NVIDIA_SETTINGS_DISTDIR)
 
 clean clobber:
-	rm -rf $(OBJS_DIR) $(DEPS_DIR) $(STAMP_C) $(NVIDIA_SETTINGS)
+	rm -rf $(OBJS_DIR) $(DEPS_DIR) $(STAMP_C) $(NVIDIA_SETTINGS) $(XNVCTRL_LIB)
 	find . -name "*~" -exec rm -f \{\} \;
 
 -include $(DEPS)

## nvidia-settings 195.36.24

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,3 @@
-DESTDIR=
-ROOT=$(DESTDIR)
-X11R6_LIB_DIR = /usr/lib
-
 #
 # nvidia-settings: A tool for configuring the NVIDIA X driver on Unix
 # and Linux systems.

=== samples/Makefile ===
#
# NV-CONTROL samples: Sample tools for configuring the NVIDIA X driver on Unix
# and Linux systems.
#
# Copyright (c) 2004-2008 NVIDIA, Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#

# Below are variables that users can override, either here or on the
# make commandline
#
# CC = gcc
# CFLAGS = -Wall
# LDFLAGS = 
# X11R6_INC_DIR = /usr/X11R6/include
# X11R6_LIB_DIR = /usr/X11R6/lib/

BUILD_OS := $(shell uname)
BUILD_ARCH := $(shell uname -m)

ifndef CC
  CC = gcc
endif

ifndef CFLAGS
  CFLAGS = -Wall 
endif

ifndef LDFLAGS
  LDFLAGS =
endif

ifndef X11R6_INC_DIR
  X11R6_INC_DIR = /usr/X11R6/include/
endif

ifndef X11R6_LIB_DIR
  ifeq ($(BUILD_OS)-$(BUILD_ARCH),Linux-x86_64)
    X11R6_LIB_DIR = /usr/X11R6/lib64
  else
    X11R6_LIB_DIR = /usr/X11R6/lib
  endif
endif

LIBXNVCTRL_DIR = ../src/libXNVCtrl


ALL_CFLAGS = $(CFLAGS) -I $(LIBXNVCTRL_DIR) -I $(X11R6_INC_DIR)
ALL_LDFLAGS = $(LDFLAGS) -L $(LIBXNVCTRL_DIR) -L $(X11R6_LIB_DIR) \
	-lXNVCtrl -lXext -lX11

SAMPLES = \
	nv-control-info \
	nv-control-dvc \
	nv-control-events \
	nv-control-dpy \
	nv-control-targets \
	nv-control-framelock \
	nv-control-gvi

all: $(SAMPLES)

% : %.c
	$(CC) $(ALL_CFLAGS) $< -o $@ $(ALL_LDFLAGS)

clean:
	rm -rf *.o *~ $(SAMPLES)

=== src/libXNVCtrl/Makefile ===
# Copyright (c) 2008 NVIDIA, Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

RANLIB ?= ranlib

libXNVCtrl.a : libXNVCtrl.a(NVCtrl.o)
	$(RANLIB) $@

NVCtrl.o : NVCtrl.h nv_control.h NVCtrlLib.h
.INTERMEDIATE: NVCtrl.o

clean ::
	rm -f libXNVCtrl.a *.o
.PHONY: clean

=== debian/changelog ===
nvidia-settings (195.36.24-1) unstable; urgency=low

  * New upstream release.
  * Remove 05_remove_X_XF86VidModeGetGammaRampSize_checks.diff - stolen
    upstream
  * Add myself to Uploaders field.

 -- Fathi Boudra <fabo@debian.org>  Tue, 18 May 2010 10:49:55 +0300

nvidia-settings (190.53-1) unstable; urgency=low

  * New upstream release (closes: #564792)

  [ Fathi Boudra ]
  * Ship nv-control-dpy binary with nvidia-settings package
    (closes: #564654)
  * Add 05_remove_X_XF86VidModeGetGammaRampSize_checks.diff:
    The protocol defines were moved to a different header in recent versions of
    the XF86VidMode protocol packages, which breaks the build.
  * Update debian/control:
    - Bump debhelper version to 7.4.13
    - Bump Standards-Version from 3.8.3 to 3.8.4 (no changes needed)
  * Update debian/copyright: add myself to packaging copyright
  * Update debian/nvidia-settings.install: add nvidia-control-dpy
  * Update debian/rules:
    - Enable parallel build (pass --parallel option to dh)
    - Build samples to ship nv-control-dpy binary
    - Add override_dh_installexamples to avoid built samples binaries install

 -- Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>  Wed, 17 Feb 2010 10:27:28 +0100

nvidia-settings (190.42-1) unstable; urgency=low

  * New upstream release (closes: #561143)

  [ Fathi Boudra ]
  * Switch to dpkg-source 3.0 (quilt) format
    - Remove quilt build dependency
    - Remove debian/README.source file
    - Remove quilt option to dh
  * Document patches with DEP-3
  * Add 04_add_missing_linked_library.diff to fix FTBFS with binutils-gold
    (closes: #556755)

 -- Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>  Wed, 06 Jan 2010 11:09:53 +0100

nvidia-settings (185.18.31-1) unstable; urgency=low

  * New upstream release

  [ Fathi Boudra ]
  * Update debian/control:
    - Bump Standards-Version from 3.8.2 to 3.8.3
  * Add debian/README.source file

 -- Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>  Sat, 22 Aug 2009 09:18:50 +0200

nvidia-settings (185.18.14-2) unstable; urgency=low

  [ Fathi Boudra ]
  * Clean XF86Config-parser directory (closes: 494456)
  * Fix some glitches on the desktop file

 -- Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>  Mon, 27 Jul 2009 09:29:21 +0200

nvidia-settings (185.18.14-1) unstable; urgency=low

  * New upstream release

  [ Fathi Boudra ]
  * Add patches:
    - 00_destdir.diff
      Define DESTDIR, ROOT and X11R6_LIB_DIR variables in the Makefile
    - 01_allow_dark_themes.diff
      Allow nvidia-settings to work with dark backgrounds - Merged from Ubuntu
    - 02_fix_manpage_type.diff
      Fix typo in nvidia-settings manpage (closes: #409589)
    - 03_build_xnvctrl_with_fpic.diff
      Build xnvctrl with -fPIC (closes: #494526)
  * Bump debian/compat from 4 to 7
  * Update debian/control:
    - Add quilt build dependency
    - Remove xutils build dependency
    - Replace xlibmesa-gl-dev by libgl1-mesa-dev build dependency
    - Bump debhelper version from 4.0.0 to 7.2
    - Bump Standards-Version from 3.6.2 to 3.8.2
    - Remove nvidia-glx recommends
  * Update debian/copyright: add some missing copyrights.
  * Update debian/docs: nvidia-settings-user-guide.txt is removed from source
  * Update debian/menu: update section to follow Debian menu policy 2.1
  * Add debian/nvidia-settings.desktop and uuencoded nvidia-settings.png files
    (closes: #317993)
  * Add debian/nvidia-settings.install to install the desktop file and
    NVCtrl related files
  * Add debian/nvidia-settings.manpages file
  * Rewrite debian/rules and use dh feature from debhelper >= 7.2

 -- Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>  Sat, 25 Jul 2009 13:16:52 +0200

nvidia-settings (180.22-1) unstable; urgency=low

  * New upstream release

 -- Randall Donald <rdonald@debian.org>  Sat, 10 Jan 2009 21:42:18 -0800

nvidia-settings (173.14.09-1) unstable; urgency=low

  * New upstream release

 -- Randall Donald <rdonald@debian.org>  Tue, 24 Jun 2008 10:41:09 -0700

nvidia-settings (169.07-1) unstable; urgency=low

  * New upstream release
  * reinclude nvctrl headers (closes: #434885)
  * depend on nvidia-glx (169.07). there are legacy versions now too.

 -- Randall Donald <rdonald@debian.org>  Sun, 23 Dec 2007 17:07:10 -0800

nvidia-settings (1.0+20070502-1) unstable; urgency=low

  * New upstream release.

 -- Randall Donald <rdonald@debian.org>  Sat, 12 May 2007 14:34:59 -0700

nvidia-settings (1.0+20060919-1) unstable; urgency=low

  * New upstream release (20060919)
  * include /usr/lib/libXNVCtrl.a (closes: #375191)

 -- Randall Donald <rdonald@debian.org>  Sat,  7 Oct 2006 14:31:44 -0700

nvidia-settings (1.0+20060516-1) unstable; urgency=low

  * add build depend on m4. (closes: #369661)
  * New upstream (nvidia-settings-1.0.tar.gz 05/16/06 )

 -- Randall Donald <rdonald@debian.org>  Fri,  2 Jun 2006 23:21:01 -0700

nvidia-settings (1.0+20060404-1) unstable; urgency=low

  * New upstream (nvidia-settings-1.0.tar.gz  04/04/06)
  * fix for xorg7 (closes: #366243)

 -- Randall Donald <rdonald@debian.org>  Wed, 17 May 2006 19:21:28 -0700

nvidia-settings (1.0+20051122-1) unstable; urgency=low

  * New upstream. (nvidia-settings-1.0-11-22-05.tar.gz) 

 -- Randall Donald <rdonald@debian.org>  Wed, 28 Dec 2005 14:10:15 -0800

nvidia-settings (1.0+20050729-1) unstable; urgency=low

  * New upstream.
  * update standards version: 3.6.2
  * correct fsf address

 -- Randall Donald <rdonald@debian.org>  Mon,  7 Nov 2005 10:54:24 -0800

nvidia-settings (1.0+20050525-2.2) unstable; urgency=low

  * Non-maintainer upload
  * corrected X11R6_LIB_DIR for x86_64 (closes: #321295, #327337)

 -- tony mancill <tmancill@debian.org>  Fri, 30 Sep 2005 08:44:56 -0700

nvidia-settings (1.0+20050525-2.1) unstable; urgency=low

  * Non-maintainer upload
  * adds build-depends on libxv-dev (closes: #324594)



=== debian/control ===
Source: nvidia-settings
Section: contrib/x11
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>, Randall Donald <rdonald@debian.org>
Build-Depends: debhelper (>= 7.4.13), sharutils, m4, libgtk2.0-dev,
 libgl1-mesa-dev | libgl-dev, libxext-dev, libxrandr-dev, libxv-dev,
 libxxf86vm-dev
Standards-Version: 3.8.4

Package: nvidia-settings
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:  Tool for configuring the NVIDIA graphics driver
 The nvidia-settings utility is a tool for configuring the NVIDIA
 Linux graphics driver.  It operates by communicating with the NVIDIA
 X driver, querying and updating state as appropriate.  This
 communication is done with the NV-CONTROL X extension.
 .
 Values such as brightness and gamma, XVideo attributes, temperature,
 and OpenGL settings can be queried and configured via nvidia-settings.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --parallel $@

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C samples
	uudecode debian/nvidia-settings.png.uue -o debian/nvidia-settings.png

override_dh_clean:
	dh_clean debian/nvidia-settings.png
	[ ! -f src/XF86Config-parser/Makefile ] || $(MAKE) -C src/XF86Config-parser clean
	[ ! -f samples/Makefile ] || $(MAKE) -C samples clean

override_dh_installexamples:
	[ ! -f samples/Makefile ] || $(MAKE) -C samples clean
	dh_installexamples

override_dh_compress:
	dh_compress --exclude=.c --exclude=.txt

.PHONY: override_dh_auto_test

## nvidia-settings 260.19.06

=== Makefile ===
#
# nvidia-settings: A tool for configuring the NVIDIA X driver on Unix
# and Linux systems.
#
# Copyright (C) 2008 NVIDIA Corporation.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of Version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See Version 2
# of the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the:
#
#           Free Software Foundation, Inc.
#           59 Temple Place - Suite 330
#           Boston, MA 02111-1307, USA
#


##############################################################################
# include common variables and functions
##############################################################################

include utils.mk


##############################################################################
# The calling Makefile may export any of the following variables; we
# assign default values if they are not exported by the caller
##############################################################################

ifndef X_LDFLAGS
  ifeq ($(TARGET_OS)-$(TARGET_ARCH),Linux-x86_64)
    X_LDFLAGS          = -L/usr/X11R6/lib64
  else
    X_LDFLAGS          = -L/usr/X11R6/lib
  endif
endif

X_CFLAGS              ?=

GL_INCLUDE_PATH       ?= /usr/include

PKG_CONFIG            ?= pkg-config

ifndef GTK_CFLAGS
  GTK_CFLAGS          := $(shell $(PKG_CONFIG) --cflags gtk+-2.0)
endif

ifndef GTK_LDFLAGS
  GTK_LDFLAGS         := $(shell $(PKG_CONFIG) --libs gtk+-2.0)
endif


##############################################################################
# The XF86Config-parser, libXNVCtrl, and common-utils directories may
# be in one of two places: either elsewhere in the driver source tree
# when building nvidia-settings as part of the NVIDIA driver build (in
# which case, XNVCTRL_DIR, XNVCTRL_ARCHIVE, XCONFIG_PARSER_DIR and
# COMMON_UTILS_DIR should be defined by the calling makefile), or
# directly in the source directory when building from the
# nvidia-settings source tarball (in which case, the below conditional
# assignments should be used)
##############################################################################

XNVCTRL_DIR           ?= src/libXNVCtrl
XNVCTRL_ARCHIVE       ?= $(XNVCTRL_DIR)/libXNVCtrl.a
XCONFIG_PARSER_DIR    ?= src/XF86Config-parser
COMMON_UTILS_DIR      ?= src/common-utils

##############################################################################
# assign variables
##############################################################################

NVIDIA_SETTINGS = $(OUTPUTDIR)/nvidia-settings

NVIDIA_SETTINGS_PROGRAM_NAME = "nvidia-settings"

NVIDIA_SETTINGS_VERSION := $(NVIDIA_VERSION)

CFLAGS += $(X_CFLAGS)

ifeq ($(TARGET_OS),SunOS)
  LDFLAGS += -Wl,-rpath=/usr/X11R6/lib
endif

LDFLAGS += $(X_LDFLAGS)

# Some older Linux distributions do not have the dynamic library
# libXxf86vm.so, though some newer Linux distributions do not have the
# static library libXxf86vm.a.  Statically link against libXxf86vm
# when building nvidia-settings within the NVIDIA driver build, but
# dynamically link against libXxf86vm in the public builds.
ifdef NV_LINK_LIBXXF86VM_STATICALLY
    LDFLAGS += -Wl,-Bstatic -lXxf86vm -Wl,-Bdynamic
else
    LDFLAGS += -lXxf86vm
endif

LDFLAGS += -lX11 -lXext
LDFLAGS += $(GTK_LDFLAGS)

MANPAGE_GZIP ?= 1

MANPAGE_gzipped 	= $(OUTPUTDIR)/nvidia-settings.1.gz
MANPAGE_not_gzipped 	= $(OUTPUTDIR)/nvidia-settings.1
ifeq ($(MANPAGE_GZIP),1)
  MANPAGE     = $(MANPAGE_gzipped)
else
  MANPAGE     = $(MANPAGE_not_gzipped)
endif
GEN_MANPAGE_OPTS   = $(OUTPUTDIR)/gen-manpage-opts
OPTIONS_1_INC      = $(OUTPUTDIR)/options.1.inc

# Include all the source lists; dist-files.mk will define SRC
include dist-files.mk

include $(XCONFIG_PARSER_DIR)/src.mk
SRC        += $(addprefix $(XCONFIG_PARSER_DIR)/,$(XCONFIG_PARSER_SRC))

include $(COMMON_UTILS_DIR)/src.mk
SRC        += $(addprefix $(COMMON_UTILS_DIR)/,$(COMMON_UTILS_SRC))

SRC        += $(STAMP_C)

OBJS        = $(call BUILD_OBJECT_LIST,$(SRC))

CFLAGS     += -I src
CFLAGS     += -I src/image_data
CFLAGS     += -I $(XNVCTRL_DIR)
CFLAGS     += -I $(XCONFIG_PARSER_DIR)/..
CFLAGS     += -I src/libXNVCtrlAttributes
CFLAGS     += -I src/xpm_data
CFLAGS     += -I src/gtk+-2.x
CFLAGS     += -I $(COMMON_UTILS_DIR)
CFLAGS     += -I $(OUTPUTDIR)

$(call BUILD_OBJECT_LIST,$(GTK_SRC)): CFLAGS += $(GTK_CFLAGS)


##############################################################################
# build rules
##############################################################################

.PNONY: all install NVIDIA_SETTINGS_install MANPAGE_install clean clobber

all: $(NVIDIA_SETTINGS) $(MANPAGE)

install: NVIDIA_SETTINGS_install MANPAGE_install

NVIDIA_SETTINGS_install: $(NVIDIA_SETTINGS)
	$(MKDIR) $(bindir)
	$(INSTALL) $(INSTALL_BIN_ARGS) $< $(bindir)/$(notdir $<)

MANPAGE_install: $(MANPAGE)
	$(MKDIR) $(mandir)
	$(INSTALL) $(INSTALL_BIN_ARGS) $< $(mandir)/$(notdir $<)

$(NVIDIA_SETTINGS): $(OBJS) $(XNVCTRL_ARCHIVE)
	$(call quiet_cmd,LINK) -o $@ $(OBJS) $(XNVCTRL_ARCHIVE) \
		$(CFLAGS) $(LDFLAGS) $(BIN_LDFLAGS)
	$(call quiet_cmd,STRIP_CMD) $@

# define the rule to build each object file
$(foreach src,$(SRC),$(eval $(call DEFINE_OBJECT_RULE,CC,$(src))))

# define the rule to generate $(STAMP_C)
$(eval $(call DEFINE_STAMP_C_RULE, $(OBJS),$(NVIDIA_SETTINGS_PROGRAM_NAME)))

clean clobber:
	rm -rf $(NVIDIA_SETTINGS) $(MANPAGE) *~ $(STAMP_C) \
		$(OUTPUTDIR)/*.o $(OUTPUTDIR)/*.d \
		$(GEN_MANPAGE_OPTS) $(OPTIONS_1_INC)


##############################################################################
# Documentation
##############################################################################

AUTO_TEXT = ".\\\" WARNING: THIS FILE IS AUTO-GENERATED!  Edit $< instead."

doc: $(MANPAGE)

GEN_MANPAGE_OPTS_SRC = src/gen-manpage-opts.c

BUILD_MANPAGE_OBJECT_LIST = \
	$(patsubst %.o,%.manpage.o,$(call BUILD_OBJECT_LIST,$(1)))

GEN_MANPAGE_OPTS_OBJS = \
	$(call BUILD_MANPAGE_OBJECT_LIST,$(GEN_MANPAGE_OPTS_SRC))

$(GEN_MANPAGE_OPTS): $(GEN_MANPAGE_OPTS_OBJS)
	$(call quiet_cmd,HOST_LINK) $(GEN_MANPAGE_OPTS_OBJS) -o $@ \
		$(HOST_CFLAGS) $(HOST_LDFLAGS) $(HOST_BIN_LDFLAGS)

# define a rule to build each GEN_MANPAGE_OPTS object file
$(foreach src,$(GEN_MANPAGE_OPTS_SRC),\
	$(eval $(call DEFINE_OBJECT_RULE_WITH_OBJECT_NAME,HOST_CC,$(src),\
		$(call BUILD_MANPAGE_OBJECT_LIST,$(src)))))

$(OPTIONS_1_INC): $(GEN_MANPAGE_OPTS)
	@./$< > $@

$(MANPAGE_not_gzipped): doc/nvidia-settings.1.m4 $(OPTIONS_1_INC)
	$(call quiet_cmd,M4) \
	  -D__HEADER__=$(AUTO_TEXT) \
	  -D__BUILD_OS__=$(TARGET_OS) \
	  -D__VERSION__=$(NVIDIA_VERSION) \
	  -D__DATE__="`$(DATE) +%F`" \
	  -I $(OUTPUTDIR) \
	  $< > $@

$(MANPAGE_gzipped): $(MANPAGE_not_gzipped)
	$(GZIP_CMD) -9f < $< > $@

=== samples/Makefile ===
#
# NV-CONTROL samples: Sample tools for configuring the NVIDIA X driver on Unix
# and Linux systems.
#
# Copyright (c) 2010 NVIDIA, Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#

##############################################################################
# include common variables and functions
##############################################################################

UTILS_MK_DIR ?= ..

include $(UTILS_MK_DIR)/utils.mk


##############################################################################
# The calling Makefile may export any of the following variables; we
# assign default values if they are not exported by the caller
##############################################################################

ifndef X_LDFLAGS
  ifeq ($(TARGET_OS)-$(TARGET_ARCH),Linux-x86_64)
    X_LDFLAGS          = -L/usr/X11R6/lib64
  else
    X_LDFLAGS          = -L/usr/X11R6/lib
  endif
endif

X_CFLAGS              ?=

LIBXNVCTRL_DIR        ?= ../src/libXNVCtrl

CFLAGS                += $(X_CFLAGS)
CFLAGS                += -I $(LIBXNVCTRL_DIR)

LDFLAGS               += $(X_LDFLAGS)
LDFLAGS               += -L $(LIBXNVCTRL_DIR)
LDFLAGS               += -lXNVCtrl -lXext -lX11


##############################################################################
# samples
##############################################################################

SAMPLE_SOURCES        += nv-control-info.c
SAMPLE_SOURCES        += nv-control-dvc.c
SAMPLE_SOURCES        += nv-control-events.c
SAMPLE_SOURCES        += nv-control-dpy.c
SAMPLE_SOURCES        += nv-control-targets.c
SAMPLE_SOURCES        += nv-control-framelock.c
SAMPLE_SOURCES        += nv-control-gvi.c


##############################################################################
# build rules
##############################################################################

.PHONY: all clean clobber

# define the rule to build each object file
$(foreach src, $(SAMPLE_SOURCES), $(eval $(call DEFINE_OBJECT_RULE,CC,$(src))))

# define the rule to link each sample app from its corresponding object file
define link_sample_from_object
  $$(OUTPUTDIR)/$(1:.c=): $$(call BUILD_OBJECT_LIST,$(1))
	$$(call quiet_cmd,LINK) $$(CFLAGS) -o $$@ $$< $$(LDFLAGS) $$(BIN_LDFLAGS)
  all:: $$(OUTPUTDIR)/$(1:.c=)
  SAMPLES += $$(OUTPUTDIR)/$(1:.c=)
endef

$(foreach sample,$(SAMPLE_SOURCES),$(eval $(call link_sample_from_object,$(sample))))

clean clobber:
	rm -rf *~ $(OUTPUTDIR)/*.o $(OUTPUTDIR)/*.d $(SAMPLES)
